#include <stdio.h>

#define FAST 1
#define SLOW 0

extern unsigned short fast_crc16(unsigned short sum,
                                 unsigned char const *p,
                                 unsigned long len);

extern unsigned short slow_crc16(unsigned short sum,
                                 unsigned char const *p,
                                 unsigned long len);

extern const unsigned short __checksum;
const unsigned int zero = 0;
#pragma segment="INTVEC"
#pragma segment="RCODE"

void main(void)
{
     unsigned short sum=0;
#if FAST
     sum=fast_crc16(sum, (unsigned char const *)__segment_begin("INTVEC"), 0x40); /* counting address 0x00-0x3F */
     sum=fast_crc16(sum, (unsigned char const *)__segment_begin("RCODE"), (unsigned long)&__checksum-0x80); /* counting address 0x80-0x7FFD */
#else
#if SLOW
     sum=slow_crc16(sum, (unsigned char const *)__segment_begin("INTVEC"), 0x40); /* counting address 0x00-0x3F */
     sum=slow_crc16(sum, (unsigned char const *)__segment_begin("RCODE"), (unsigned long)&__checksum-0x80); /* counting address 0x80-0x7FFD */
     sum=slow_crc16(sum, (unsigned char const *)&zero, 2); /* two extra zero values are needed for this method */
#endif
#endif

     if(sum!=__checksum)
          printf("Checksum failed: 0x%hx (counted) vs 0x%hx (from xlink)\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
